/* mnet.c - mesh networking utils
 * marius aamodt eriksen (marius@umich.edu)
 * $Id: mnet.c,v 1.2 2001/09/16 06:41:18 beriksen Exp $ */


#include <sys/types.h>
#include <sys/socket.h>

#include "mnet.h"

#if defined(SENDN) || defined(RECVN)
ssize_t
#if defined(RECVN)
recvn
#elif defined(SENDN)
sendn
#endif
(int s, void *buf, size_t len, int flags)
{
	unsigned bytes = 0, bytes_left = len;
	
	while (bytes_left > 0) {
		if ( (bytes =
#if defined(RECVN)
			  recv
#elif defined(SENDN)
			  send
#endif
			  (s, buf+(len-bytes_left), bytes_left, flags)) != -1 )
			bytes_left -= bytes;
		else
			return -1;
	}
	return len;
}
#endif /* defined(SENDN) || defined(RECVN) */

#if !defined(RECVN) && !defined(SENDN)
/* void */
#endif
